#include "user.h"
#include "osc.h"
#include "disp.h"
#include "graph.h"


void avr_init(void);

unsigned char k_fr_div=0;
unsigned char k_att=0;

unsigned char k_sync,u_bat;

volatile unsigned char SRAM_i,i_razv;

volatile unsigned char adc_array[0xff];

volatile unsigned char adc_array_tmp[0xff];

unsigned char k_inp_sw,k_s,k_sync_sw,k_h_l,k_osc;



ISR(INT0_vect) //  () 
{
	TIMSK|=_BV(TOIE0);
	return;
}

ISR(INT1_vect) //     
{

	TIMSK&=~_BV(TOIE0);
	
	EIMSK&=~_BV(INT0);
	EIMSK&=~_BV(INT1);
	
	gird (gird_color);
	axis (gird_color);
	
	PORTD|=_BV(r_w);
	run_osc();
	
	//   
	for (SRAM_i=0;SRAM_i<0xff;SRAM_i++)
	{
		mcu_clk_imp();
		adc_array[SRAM_i]= ((((PINC)*29)/64)+34);
	}
	
	//PORTD&=~_BV(r_w);
	
	//  

	for(i_razv=0;i_razv<174;i_razv++)
	{
		//gclcd_put_pixel(i_razv+1,adc_array_tmp[i_razv],BLACK);
		solid_beam_clear(i_razv+1, adc_array_tmp[i_razv], adc_array_tmp[i_razv+1]);
	}
		
	for(i_razv=0;i_razv<174;i_razv++)
	{
		//gclcd_put_pixel(i_razv+1,adc_array[i_razv],WHITE);
		solid_beam_set(i_razv+1, adc_array[i_razv], adc_array[i_razv+1]);
		adc_array_tmp[i_razv] = adc_array[i_razv];
	}
	
	//pause (300);

	return;
}


ISR(TIMER0_OVF_vect)	//""     SRAM
{
		
		TIMSK&=~_BV(TOIE0);
		EIMSK&=~_BV(INT1);
		
		PORTD&=~_BV(r_w);
		run_osc();
		
		pause(500); //    
		
		u_bat=res_ADC();
		bat_ch (u_bat);
		
		EIMSK|=_BV(INT1);
		EIMSK&=~_BV(INT0);
		
	return;
}


int main (void) 

{	
	//
	avr_init();
	port_init();
	lcd_init_c();
	
	backcolor=BLACK;
	textcolor=GREEN;
	fill_screen(BLACK); 
	
	
	gird (gird_color);
	axis (gird_color);
	
	u_bat=res_ADC();
	bat_ch (u_bat);
	
	textcolor=0x6fdc;
	gclcd_put_txt(34,18,"V/d",0);
	gclcd_put_txt(42,1,"s/d",0);
	
	//k_osc=eeprom_read_byte(0x40);
	
	//k_att=eeprom_read_byte(0x20);
	att_sel(k_att);
	v_d_ind (k_att);
	
	//k_fr_div=eeprom_read_byte(0x10);
	freq_div_sel(k_fr_div);
	f_d_ind (k_fr_div);
	
	inp_sw(k_inp_sw);
	
	// sync
	sync_sw(k_sync_sw);
	
	sinc_on_off_ind(k_s);
	
	h_l_sync (k_h_l);

	sei();
	
	
	for(;;)
	{	
		
		
		//gclcd_put_val_3dig(100,100,matrix_kbd(),0);
		///*
		if(matrix_kbd()==76)
		{
			
			k_osc++;
			if (k_osc>1)	k_osc=0;
			eeprom_write_byte(0x40,k_osc);
			
		}
		
		// attenuator
//##########################################
		if(matrix_kbd()==184)
		{
			k_att++;
			if (k_att>5)	k_att=0;
			eeprom_write_byte(0x20,k_att);
			att_sel(k_att);
			v_d_ind (k_att);
		}
		
		if(matrix_kbd()==180)
		{
			k_att--;
			if (k_att>5)	k_att=5;
			eeprom_write_byte(0x20,k_att);
			att_sel(k_att);
			v_d_ind (k_att);
		}
//############################################

	// freq divider
//#########################################
		if(matrix_kbd()==212)
		{
			k_fr_div++;
			if (k_fr_div>16)	k_fr_div=0;
			eeprom_write_byte(0x10,k_fr_div);
			freq_div_sel(k_fr_div);
			f_d_ind (k_fr_div);
		}
		
		if(matrix_kbd()==116)
		{
			k_fr_div--;
			if (k_fr_div>15)	k_fr_div=15;
			eeprom_write_byte(0x10,k_fr_div);
			freq_div_sel(k_fr_div);
			f_d_ind (k_fr_div);
		}
//#############################################
		
		// input switch
//############################################
		if(matrix_kbd()==108)
		{
			k_inp_sw++;
			if (k_inp_sw>1)	k_inp_sw=0;
			eeprom_write_byte(0x01,k_inp_sw);
			inp_sw(k_inp_sw);
		}
		
		// syncronization switch
//############################################
		if(matrix_kbd()==172)
		{
			k_sync_sw++;
			if (k_sync_sw>1)	k_sync_sw=0;
			//eeprom_write_byte(0x02,k_sync_sw);
			sync_sw(k_sync_sw);
		}
//##############################################
		
		
		if(matrix_kbd()==216)
		{
			k_s++;
			if (k_s>1)	k_s=0;
			sinc_on_off_ind(k_s);
			pause (1000);
			sinc_on_off(k_s);
			
			
		}
		
		if(matrix_kbd()==204)
		{
			k_h_l++;
			if(k_h_l>1)	k_h_l=0;
			h_l_sync (k_h_l);
		}
		
		sinc_on_off(k_s);
		//*/
	}
}

void avr_init (void)
{
//----------------------------------------------------

//   KS107
	PORTA=0x00;
	DDRA=0xff;

//   
	PORTF=0b00000000;
	DDRF= 0b11111110;


	PORTB=0;
	DDRB= 0xff;

// 
	PORTE=0b11111111;
	DDRE= 0b00000000;

//
	PORTC=0x00;
	DDRC= 0x00;
	
//  

	PORTD=0b00000011;
	DDRD= 0b11111100;
	
	PORTG=0b00000;
	DDRG= 0b11111;


//-----------------------------------------------------
// 1    

	//TCCR1A=0b10000001;
	//TCCR1B=0b00001001;
	
	//  
	//OCR1A=25;
//----------------------------------------------------
// 
	EIMSK=0;
	EICRA=0b00000000;
	EICRB=0;

//-----------------------------------------------------
// T0

	TCCR0=0b00000101; //    SRAM
//------------------------------------------------------
//-----------------------------------------------------
// T2
//   LPH8836

	TCCR2=0b01101001; 
	OCR2=0x30; // 
	
	//TCCR0=0b01101001; 
	//OCR0=0x12; // 
//------------------------------------------------------
//  
	
	ADMUX &= 0x7F & 0xF1; ADMUX |= 0x40 | 0x00| 0x20;   

	ADCSRA &= 0xFB; ADCSRA |= 0x80 | 0x00 | 0x20 | 0x03; 
	
	ADCSRA |= 0x40;
}
