#include "osc.h"


void run_osc (void)
{
	PORTG&=~_BV(run);
	PORTG|=_BV(run);
	pause(2);
	PORTG&=~_BV(run);
	pause(2);
	return;
}

void mcu_clk_imp(void)
{
	PORTD&=~_BV(clk_mcu);
	PORTD|=_BV(clk_mcu);
	pause(2);
	PORTD&=~_BV(clk_mcu);
	pause(2);
	return;
}

void freq_div_sel(unsigned char f_d)
{
	PORTG&=~_BV(fr_div_clr);
	PORTG|=_BV(fr_div_clr);
	pause(1);
	PORTG&=~_BV(fr_div_clr);
	pause(1);
	
	for (unsigned char c=0;c<=f_d;c++)
	{
		PORTG&=~_BV(fr_div_set);
		PORTG|=_BV(fr_div_set);
		pause(2);
		PORTG&=~_BV(fr_div_set);
		pause(2);
	}
	return;
}

void att_sel(unsigned char d)
{
	PORTD&=~_BV(att_clr);
	PORTD|=_BV(att_clr);
	pause(1);
	PORTD&=~_BV(att_clr);
	pause(1);
	
	for (unsigned char c=0;c<=d;c++)
	{
		PORTD&=~_BV(att_set	);
		PORTD|=_BV(att_set);
		pause(1);
		PORTD&=~_BV(att_set);
		pause(1);
	}
	return;
}


void inp_sw(unsigned char k_inp_sw)
{
	switch (k_inp_sw)
	{
		case 0: 
			PORTG|=_BV(inp_sel);
			//glcdRectangle(150, 8, 17, 20,0xF800);
			gclcd_put_txt(140,10,"DC",0);
			break;
		case 1:
			PORTG&=~_BV(inp_sel);
			//glcdRectangle(150, 8, 17, 20,0xF800);
			gclcd_put_txt(140,10,"AC",0);
			break;
		default:
			break;
	}
	return;
}


void sync_sw(unsigned char k_sync_sw)
{
	switch (k_sync_sw)
	{
		case 0: //	
			PORTF&=~_BV(sync_sw_pin);
			//glcdRectangle(120, 8, 17, 28,0xF800);
			//PORTG&=~_BV(PG2);
			gclcd_put_txt(110,10,"int",0);
			break;
		case 1:		//
			PORTF|=_BV(sync_sw_pin);
			//PORTG|=_BV(PG2);
			//glcdRectangle(120, 8, 17, 28,0xF800);
			gclcd_put_txt(110,10,"ext",0);
			break;
		default:
			PORTF&=~_BV(sync_sw_pin);
			break;
	}
	return;
}

// math
/*
unsigned char max_arr(unsigned char arr[])
{ 
	unsigned char tmp_=arr[0],i;
	for (i=0;i<126;i++)
	{
		if(tmp_<arr[i])	tmp_=arr[i];
	}
	return 46-tmp_;
}

unsigned char min_arr(unsigned char arr[])
{ 
	unsigned char tmp_=arr[0],i;
	for (i=0;i<126;i++)
	{
		if(tmp_>arr[i])	tmp_=arr[i];
	}
	return 46-tmp_;
}


unsigned char av_arr(unsigned char arr[])
{ 
	unsigned int tmp_=0;
	unsigned char i;
	for (i=0;i<0xff;i++)
	{
		tmp_=tmp_+arr[i];
	}
	tmp_=tmp_/0xff;
	return 46-tmp_;
}

unsigned char get_fr (unsigned char arr[])
{
	unsigned char U_eg=25,i_eg_1=0,i_eg_2=0,i_eg_3=0, i=0;
	
	while ((arr[i]==U_eg)||i==127)	i++;
	i_eg_1=i;
	
	while ((arr[i]==U_eg) ||i==127)	i++;
	i_eg_2=i;
	
	while ((arr[i]==U_eg) ||i==127)	i++;
	i_eg_3=i;

	return i_eg_3-i_eg_1;
	
}
*/
void sinc_on_off(unsigned char k_s)
{

		switch (k_s)
		{
			case 0:
				TIMSK|=_BV(TOIE0);
				break;
			case 1:
				EIMSK|=_BV(INT0); 
				break;
			default:
				TIMSK|=_BV(TOIE0);
				break;
		}
	return;
}

void sinc_on_off_ind(unsigned char k_s)
{
	switch (k_s)
	{
		case 0: //	
			//glcdRectangle(82, 8, 17, 36,0xF800);
			gclcd_put_txt(72,10,"A",0);
			
			break;
		case 1:		//
			//glcdRectangle(82, 8, 17, 36,0xF800);
			gclcd_put_txt(72,10,"S",0);
			
			break;
		default:
			break;
	}
}

void h_l_sync (unsigned char k_h_l)
{
	switch (k_h_l)
	{
		case 0: 
			PORTG&=~_BV(sync_h_l);
			gclcd_put_txt(87,10,"hi",0);
			//glcdRectangle(150, 8, 17, 20,0xF800);
			break;
		case 1:
			PORTG|=_BV(sync_h_l);
			gclcd_put_txt(87,10,"lo",0);
			//glcdRectangle(150, 8, 17, 20,0xF800);
			break;
		default:
			break;
	}
}

void v_d_ind (unsigned char k_att)
{
	switch (k_att)
	{
		case 0: 
			gclcd_put_txt(1,18," 1  ",0);
			break;
		case 1:
			gclcd_put_txt(1,18,"500m",0);
			break;
		case 2:
			gclcd_put_txt(1,18,"200m",0);
			break;
		case 3:
			gclcd_put_txt(1,18,"100m",0);
			break;
		case 4:
			gclcd_put_txt(1,18," 50m",0);
			break;
		case 5:
			gclcd_put_txt(1,18," 20m",0);
			break;
		default:
			break;
	}
	return;
}
///*
void f_d_ind (unsigned char k_fr_div) // 40 MHz cklocking
{
	switch (k_fr_div)
	{
		case 0: 
			gclcd_put_txt(1,1,"0.25mk",0);
			break;
		case 1:
			gclcd_put_txt(1,1,"0.5 mk",0);
			break;
		case 2:
			gclcd_put_txt(1,1," 1  mk",0);
			break;
		case 3:
			gclcd_put_txt(1,1," 2  mk",0);
			break;
		case 4:
			gclcd_put_txt(1,1," 4  mk",0);
			break;
		case 5:
			gclcd_put_txt(1,1," 8  mk",0);
			break;
		case 6:
			gclcd_put_txt(1,1,"16  mk",0);
			break;
		case 7:
			gclcd_put_txt(1,1,"32  mk",0);
			break;
		case 8:
			gclcd_put_txt(1,1,"64  mk",0);
			break;
		case 9:
			gclcd_put_txt(1,1,"128 mk",0);
			break;
		case 10:
			gclcd_put_txt(1,1,"256 mk",0);
			break;
		case 11:
			gclcd_put_txt(1,1,"512 mk",0);
			break;
		case 12:
			gclcd_put_txt(1,1,"1.00 m",0);
			break;
		case 13:
			gclcd_put_txt(1,1,"2.00 m",0);
			break;
		case 14:
			gclcd_put_txt(1,1,"4.00 m",0);
			break;
		case 15:
			gclcd_put_txt(1,1,"8.00 m",0);
			break;
		default:
			break;
	}
	return;
}
/*/
void f_d_ind (unsigned char k_fr_div) // 66 MHz cklocking
{
	switch (k_fr_div)
	{
		case 0: 
			gclcd_put_txt(1,1,"0.16u",0);
			break;
		case 1:
			gclcd_put_txt(1,1,"0.32u",0);
			break;
		case 2:
			gclcd_put_txt(1,1,"0.64u",0);
			break;
		case 3:
			gclcd_put_txt(1,1,"1.28u",0);
			break;
		case 4:
			gclcd_put_txt(1,1,"2.6 u",0);
			break;
		case 5:
			gclcd_put_txt(1,1,"5.4 u",0);
			break;
		case 6:
			gclcd_put_txt(1,1," 10 u",0);
			break;
		case 7:
			gclcd_put_txt(1,1," 20 u",0);
			break;
		case 8:
			gclcd_put_txt(1,1," 40 u",0);
			break;
		case 9:
			gclcd_put_txt(1,1," 80 u",0);
			break;
		case 10:
			gclcd_put_txt(1,1,"160 u",0);
			break;
		case 11:
			gclcd_put_txt(1,1,"320 u",0);
			break;
		case 12:
			gclcd_put_txt(1,1,"640 u",0);
			break;
		case 13:
			gclcd_put_txt(1,1,"1.28m",0);
			break;
		case 14:
			gclcd_put_txt(1,1,"2.56m",0);
			break;
		case 15:
			gclcd_put_txt(1,1,"5.12m",0);
			break;
		default:
			break;
	}
	return;
}
*/
